# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### TypeSafeRestApi <a name="TypeSafeRestApi" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi"></a>

A construct for creating an api gateway rest api based on the definition in the OpenAPI spec.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer"></a>

```typescript
import { TypeSafeRestApi } from '@aws-prototyping-sdk/type-safe-api'

new TypeSafeRestApi(scope: Construct, id: string, props: TypeSafeRestApiProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.props">props</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApiProps">TypeSafeRestApiProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.Initializer.parameter.props"></a>

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApiProps">TypeSafeRestApiProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.isConstruct"></a>

```typescript
import { TypeSafeRestApi } from '@aws-prototyping-sdk/type-safe-api'

TypeSafeRestApi.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.api">api</a></code> | <code>aws-cdk-lib.aws_apigateway.SpecRestApi</code> | Underlying API Gateway API construct. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.extendedApiSpecification">extendedApiSpecification</a></code> | <code>any</code> | The OpenAPI specification with applied API gateway extensions. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.ipSet">ipSet</a></code> | <code>aws-cdk-lib.aws_wafv2.CfnIPSet</code> | Reference to the IP set if created. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.webAcl">webAcl</a></code> | <code>aws-cdk-lib.aws_wafv2.CfnWebACL</code> | Reference to the webacl, if created. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.webAclAssociation">webAclAssociation</a></code> | <code>aws-cdk-lib.aws_wafv2.CfnWebACLAssociation</code> | Reference to the web acl association if created. |

---

##### `node`<sup>Required</sup> <a name="node" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `api`<sup>Required</sup> <a name="api" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.api"></a>

```typescript
public readonly api: SpecRestApi;
```

- *Type:* aws-cdk-lib.aws_apigateway.SpecRestApi

Underlying API Gateway API construct.

---

##### `extendedApiSpecification`<sup>Required</sup> <a name="extendedApiSpecification" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.extendedApiSpecification"></a>

```typescript
public readonly extendedApiSpecification: any;
```

- *Type:* any

The OpenAPI specification with applied API gateway extensions.

---

##### `ipSet`<sup>Optional</sup> <a name="ipSet" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.ipSet"></a>

```typescript
public readonly ipSet: CfnIPSet;
```

- *Type:* aws-cdk-lib.aws_wafv2.CfnIPSet

Reference to the IP set if created.

---

##### `webAcl`<sup>Optional</sup> <a name="webAcl" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.webAcl"></a>

```typescript
public readonly webAcl: CfnWebACL;
```

- *Type:* aws-cdk-lib.aws_wafv2.CfnWebACL

Reference to the webacl, if created.

---

##### `webAclAssociation`<sup>Optional</sup> <a name="webAclAssociation" id="@aws-prototyping-sdk/type-safe-api.TypeSafeRestApi.property.webAclAssociation"></a>

```typescript
public readonly webAclAssociation: CfnWebACLAssociation;
```

- *Type:* aws-cdk-lib.aws_wafv2.CfnWebACLAssociation

Reference to the web acl association if created.

---


## Structs <a name="Structs" id="Structs"></a>

### ApiGatewayIntegration <a name="ApiGatewayIntegration" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration"></a>

Represents an api gateway integration.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration.html)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.Initializer"></a>

```typescript
import { ApiGatewayIntegration } from '@aws-prototyping-sdk/type-safe-api'

const apiGatewayIntegration: ApiGatewayIntegration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.cacheKeyParameters">cacheKeyParameters</a></code> | <code>string[]</code> | A list of request parameters whose values are to be cached. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.cacheNamespace">cacheNamespace</a></code> | <code>string</code> | An API-specific tag group of related cached parameters. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.connectionId">connectionId</a></code> | <code>string</code> | The ID of a VpcLink for the private integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.connectionType">connectionType</a></code> | <code>string</code> | The integration connection type. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.contentHandling">contentHandling</a></code> | <code>string</code> | Request payload encoding conversion types. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.credentials">credentials</a></code> | <code>string</code> | For AWS IAM role-based credentials, specify the ARN of an appropriate IAM role. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.httpMethod">httpMethod</a></code> | <code>string</code> | The HTTP method used in the integration request. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.passthroughBehavior">passthroughBehavior</a></code> | <code>string</code> | Specifies how a request payload of unmapped content type is passed through the integration request without modification. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.requestParameters">requestParameters</a></code> | <code>{[ key: string ]: string}</code> | Specifies mappings from method request parameters to integration request parameters. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.requestTemplates">requestTemplates</a></code> | <code>{[ key: string ]: string}</code> | Mapping templates for a request payload of specified MIME types. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.responses">responses</a></code> | <code>{[ key: string ]: <a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse">ApiGatewayIntegrationResponse</a>}</code> | Defines the method's responses and specifies desired parameter mappings or payload mappings from integration responses to method responses. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.timeoutInMillis">timeoutInMillis</a></code> | <code>number</code> | Custom timeout between 50 and 29,000 milliseconds. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.tlsConfig">tlsConfig</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig">ApiGatewayIntegrationTlsConfig</a></code> | Specifies the TLS configuration for an integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.type">type</a></code> | <code>string</code> | The type of integration with the specified backend. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.uri">uri</a></code> | <code>string</code> | The endpoint URI of the backend. |

---

##### `cacheKeyParameters`<sup>Optional</sup> <a name="cacheKeyParameters" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.cacheKeyParameters"></a>

```typescript
public readonly cacheKeyParameters: string[];
```

- *Type:* string[]

A list of request parameters whose values are to be cached.

---

##### `cacheNamespace`<sup>Optional</sup> <a name="cacheNamespace" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.cacheNamespace"></a>

```typescript
public readonly cacheNamespace: string;
```

- *Type:* string

An API-specific tag group of related cached parameters.

---

##### `connectionId`<sup>Optional</sup> <a name="connectionId" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.connectionId"></a>

```typescript
public readonly connectionId: string;
```

- *Type:* string

The ID of a VpcLink for the private integration.

> [https://docs.aws.amazon.com/apigateway/latest/api/API_VpcLink.html](https://docs.aws.amazon.com/apigateway/latest/api/API_VpcLink.html)

---

##### `connectionType`<sup>Optional</sup> <a name="connectionType" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.connectionType"></a>

```typescript
public readonly connectionType: string;
```

- *Type:* string

The integration connection type.

The valid value is "VPC_LINK" for private integration or "INTERNET", otherwise.

---

##### `contentHandling`<sup>Optional</sup> <a name="contentHandling" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.contentHandling"></a>

```typescript
public readonly contentHandling: string;
```

- *Type:* string

Request payload encoding conversion types.

Valid values are 1) CONVERT_TO_TEXT, for converting a binary payload
into a base64-encoded string or converting a text payload into a utf-8-encoded string or passing through the text
payload natively without modification, and 2) CONVERT_TO_BINARY, for converting a text payload into a
base64-decoded blob or passing through a binary payload natively without modification.

---

##### `credentials`<sup>Optional</sup> <a name="credentials" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.credentials"></a>

```typescript
public readonly credentials: string;
```

- *Type:* string

For AWS IAM role-based credentials, specify the ARN of an appropriate IAM role.

If unspecified, credentials default
to resource-based permissions that must be added manually to allow the API to access the resource. For more
information, see Granting Permissions Using a Resource Policy.

Note: When using IAM credentials, make sure that AWS STS Regional endpoints are enabled for the Region where this
API is deployed for best performance.

---

##### `httpMethod`<sup>Optional</sup> <a name="httpMethod" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.httpMethod"></a>

```typescript
public readonly httpMethod: string;
```

- *Type:* string

The HTTP method used in the integration request.

For Lambda function invocations, the value must be POST.

---

##### `passthroughBehavior`<sup>Optional</sup> <a name="passthroughBehavior" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.passthroughBehavior"></a>

```typescript
public readonly passthroughBehavior: string;
```

- *Type:* string

Specifies how a request payload of unmapped content type is passed through the integration request without modification.

Supported values are when_no_templates, when_no_match, and never.

> [https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html#passthroughBehavior](https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html#passthroughBehavior)

---

##### `requestParameters`<sup>Optional</sup> <a name="requestParameters" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.requestParameters"></a>

```typescript
public readonly requestParameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Specifies mappings from method request parameters to integration request parameters.

Supported request parameters
are querystring, path, header, and body.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-requestParameters.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-requestParameters.html)

---

##### `requestTemplates`<sup>Optional</sup> <a name="requestTemplates" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.requestTemplates"></a>

```typescript
public readonly requestTemplates: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Mapping templates for a request payload of specified MIME types.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-requestTemplates.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-requestTemplates.html)

---

##### `responses`<sup>Optional</sup> <a name="responses" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.responses"></a>

```typescript
public readonly responses: {[ key: string ]: ApiGatewayIntegrationResponse};
```

- *Type:* {[ key: string ]: <a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse">ApiGatewayIntegrationResponse</a>}

Defines the method's responses and specifies desired parameter mappings or payload mappings from integration responses to method responses.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-responses.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-swagger-extensions-integration-responses.html)

---

##### `timeoutInMillis`<sup>Optional</sup> <a name="timeoutInMillis" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.timeoutInMillis"></a>

```typescript
public readonly timeoutInMillis: number;
```

- *Type:* number

Custom timeout between 50 and 29,000 milliseconds.

The default value is 29,000 milliseconds or 29 seconds.

---

##### `tlsConfig`<sup>Optional</sup> <a name="tlsConfig" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.tlsConfig"></a>

```typescript
public readonly tlsConfig: ApiGatewayIntegrationTlsConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig">ApiGatewayIntegrationTlsConfig</a>

Specifies the TLS configuration for an integration.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-extensions-integration-tls-config.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-extensions-integration-tls-config.html)

---

##### `type`<sup>Optional</sup> <a name="type" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

The type of integration with the specified backend.

> [https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html#type](https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html#type)

---

##### `uri`<sup>Optional</sup> <a name="uri" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegration.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

The endpoint URI of the backend.

For integrations of the aws type, this is an ARN value.
For the HTTP integration, this is the URL of the HTTP endpoint including the https or http scheme.

---

### ApiGatewayIntegrationResponse <a name="ApiGatewayIntegrationResponse" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse"></a>

API Gateway integration response.

> [https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html](https://docs.aws.amazon.com/apigateway/latest/api/API_Integration.html)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.Initializer"></a>

```typescript
import { ApiGatewayIntegrationResponse } from '@aws-prototyping-sdk/type-safe-api'

const apiGatewayIntegrationResponse: ApiGatewayIntegrationResponse = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.responseParameters">responseParameters</a></code> | <code>{[ key: string ]: string}</code> | Specifies parameter mappings for the response. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.responseTemplates">responseTemplates</a></code> | <code>{[ key: string ]: string}</code> | Specifies MIME type-specific mapping templates for the response’s payload. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.statusCode">statusCode</a></code> | <code>string</code> | HTTP status code for the method response. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.contentHandling">contentHandling</a></code> | <code>string</code> | Response payload encoding conversion types. |

---

##### `responseParameters`<sup>Required</sup> <a name="responseParameters" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.responseParameters"></a>

```typescript
public readonly responseParameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Specifies parameter mappings for the response.

---

##### `responseTemplates`<sup>Required</sup> <a name="responseTemplates" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.responseTemplates"></a>

```typescript
public readonly responseTemplates: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Specifies MIME type-specific mapping templates for the response’s payload.

---

##### `statusCode`<sup>Required</sup> <a name="statusCode" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.statusCode"></a>

```typescript
public readonly statusCode: string;
```

- *Type:* string

HTTP status code for the method response.

---

##### `contentHandling`<sup>Optional</sup> <a name="contentHandling" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationResponse.property.contentHandling"></a>

```typescript
public readonly contentHandling: string;
```

- *Type:* string

Response payload encoding conversion types.

Valid values are 1) CONVERT_TO_TEXT, for converting a binary payload
into a base64-encoded string or converting a text payload into a utf-8-encoded string or passing through the text
payload natively without modification, and 2) CONVERT_TO_BINARY, for converting a text payload into a
base64-decoded blob or passing through a binary payload natively without modification.

---

### ApiGatewayIntegrationTlsConfig <a name="ApiGatewayIntegrationTlsConfig" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig"></a>

Specifies the TLS configuration for an integration.

> [https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-extensions-integration-tls-config.html](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-extensions-integration-tls-config.html)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig.Initializer"></a>

```typescript
import { ApiGatewayIntegrationTlsConfig } from '@aws-prototyping-sdk/type-safe-api'

const apiGatewayIntegrationTlsConfig: ApiGatewayIntegrationTlsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig.property.insecureSkipVerification">insecureSkipVerification</a></code> | <code>boolean</code> | Specifies whether or not API Gateway skips verification that the certificate for an integration endpoint is issued by a supported certificate authority. |

---

##### `insecureSkipVerification`<sup>Optional</sup> <a name="insecureSkipVerification" id="@aws-prototyping-sdk/type-safe-api.ApiGatewayIntegrationTlsConfig.property.insecureSkipVerification"></a>

```typescript
public readonly insecureSkipVerification: boolean;
```

- *Type:* boolean

Specifies whether or not API Gateway skips verification that the certificate for an integration endpoint is issued by a supported certificate authority.

This isn’t recommended, but it enables you to use certificates that are
signed by private certificate authorities, or certificates that are self-signed. If enabled, API Gateway still
performs basic certificate validation, which includes checking the certificate's expiration date, hostname, and
presence of a root certificate authority. Supported only for HTTP and HTTP_PROXY integrations.

---

### ApiKeyOptions <a name="ApiKeyOptions" id="@aws-prototyping-sdk/type-safe-api.ApiKeyOptions"></a>

Options for API keys.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.ApiKeyOptions.Initializer"></a>

```typescript
import { ApiKeyOptions } from '@aws-prototyping-sdk/type-safe-api'

const apiKeyOptions: ApiKeyOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiKeyOptions.property.source">source</a></code> | <code>aws-cdk-lib.aws_apigateway.ApiKeySourceType</code> | Source type for an API key. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.ApiKeyOptions.property.requiredByDefault">requiredByDefault</a></code> | <code>boolean</code> | Set to true to require an API key on all operations by default. |

---

##### `source`<sup>Required</sup> <a name="source" id="@aws-prototyping-sdk/type-safe-api.ApiKeyOptions.property.source"></a>

```typescript
public readonly source: ApiKeySourceType;
```

- *Type:* aws-cdk-lib.aws_apigateway.ApiKeySourceType

Source type for an API key.

---

##### `requiredByDefault`<sup>Optional</sup> <a name="requiredByDefault" id="@aws-prototyping-sdk/type-safe-api.ApiKeyOptions.property.requiredByDefault"></a>

```typescript
public readonly requiredByDefault: boolean;
```

- *Type:* boolean

Set to true to require an API key on all operations by default.

Only applicable when the source is HEADER.

---

### AuthorizerProps <a name="AuthorizerProps" id="@aws-prototyping-sdk/type-safe-api.AuthorizerProps"></a>

Properties for an authorizer.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.AuthorizerProps.Initializer"></a>

```typescript
import { AuthorizerProps } from '@aws-prototyping-sdk/type-safe-api'

const authorizerProps: AuthorizerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizationType">authorizationType</a></code> | <code>aws-cdk-lib.aws_apigateway.AuthorizationType</code> | The type of the authorizer. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizerId">authorizerId</a></code> | <code>string</code> | The unique identifier for the authorizer. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizationScopes">authorizationScopes</a></code> | <code>string[]</code> | Scopes for the authorizer, if any. |

---

##### `authorizationType`<sup>Required</sup> <a name="authorizationType" id="@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizationType"></a>

```typescript
public readonly authorizationType: AuthorizationType;
```

- *Type:* aws-cdk-lib.aws_apigateway.AuthorizationType

The type of the authorizer.

---

##### `authorizerId`<sup>Required</sup> <a name="authorizerId" id="@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizerId"></a>

```typescript
public readonly authorizerId: string;
```

- *Type:* string

The unique identifier for the authorizer.

---

##### `authorizationScopes`<sup>Optional</sup> <a name="authorizationScopes" id="@aws-prototyping-sdk/type-safe-api.AuthorizerProps.property.authorizationScopes"></a>

```typescript
public readonly authorizationScopes: string[];
```

- *Type:* string[]

Scopes for the authorizer, if any.

---

### CidrAllowList <a name="CidrAllowList" id="@aws-prototyping-sdk/type-safe-api.CidrAllowList"></a>

Representation of a CIDR range.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.CidrAllowList.Initializer"></a>

```typescript
import { CidrAllowList } from '@aws-prototyping-sdk/type-safe-api'

const cidrAllowList: CidrAllowList = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CidrAllowList.property.cidrRanges">cidrRanges</a></code> | <code>string[]</code> | Specify an IPv4 address by using CIDR notation. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CidrAllowList.property.cidrType">cidrType</a></code> | <code>string</code> | Type of CIDR range. |

---

##### `cidrRanges`<sup>Required</sup> <a name="cidrRanges" id="@aws-prototyping-sdk/type-safe-api.CidrAllowList.property.cidrRanges"></a>

```typescript
public readonly cidrRanges: string[];
```

- *Type:* string[]

Specify an IPv4 address by using CIDR notation.

For example:
To configure AWS WAF to allow, block, or count requests that originated from the IP address 192.0.2.44, specify 192.0.2.44/32 .
To configure AWS WAF to allow, block, or count requests that originated from IP addresses from 192.0.2.0 to 192.0.2.255, specify 192.0.2.0/24 .

For more information about CIDR notation, see the Wikipedia entry Classless Inter-Domain Routing .

Specify an IPv6 address by using CIDR notation. For example:
To configure AWS WAF to allow, block, or count requests that originated from the IP address 1111:0000:0000:0000:0000:0000:0000:0111, specify 1111:0000:0000:0000:0000:0000:0000:0111/128 .
To configure AWS WAF to allow, block, or count requests that originated from IP addresses 1111:0000:0000:0000:0000:0000:0000:0000 to 1111:0000:0000:0000:ffff:ffff:ffff:ffff, specify 1111:0000:0000:0000:0000:0000:0000:0000/64 .

---

##### `cidrType`<sup>Required</sup> <a name="cidrType" id="@aws-prototyping-sdk/type-safe-api.CidrAllowList.property.cidrType"></a>

```typescript
public readonly cidrType: string;
```

- *Type:* string

Type of CIDR range.

---

### CodeGenerationSourceOptions <a name="CodeGenerationSourceOptions" id="@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions"></a>

Options for the source files used for code generation.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions.Initializer"></a>

```typescript
import { CodeGenerationSourceOptions } from '@aws-prototyping-sdk/type-safe-api'

const codeGenerationSourceOptions: CodeGenerationSourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions.property.specPath">specPath</a></code> | <code>string</code> | Path to the OpenAPI specification. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions.property.smithyJsonModelPath">smithyJsonModelPath</a></code> | <code>string</code> | Path to the Smithy json model if applicable. |

---

##### `specPath`<sup>Required</sup> <a name="specPath" id="@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions.property.specPath"></a>

```typescript
public readonly specPath: string;
```

- *Type:* string

Path to the OpenAPI specification.

---

##### `smithyJsonModelPath`<sup>Optional</sup> <a name="smithyJsonModelPath" id="@aws-prototyping-sdk/type-safe-api.CodeGenerationSourceOptions.property.smithyJsonModelPath"></a>

```typescript
public readonly smithyJsonModelPath: string;
```

- *Type:* string

Path to the Smithy json model if applicable.

---

### CognitoAuthorizerProps <a name="CognitoAuthorizerProps" id="@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps"></a>

Properties used to configure a cognito authorizer.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.Initializer"></a>

```typescript
import { CognitoAuthorizerProps } from '@aws-prototyping-sdk/type-safe-api'

const cognitoAuthorizerProps: CognitoAuthorizerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.authorizerId">authorizerId</a></code> | <code>string</code> | Unique identifier for this authorizer. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.userPools">userPools</a></code> | <code>aws-cdk-lib.aws_cognito.IUserPool[]</code> | The Cognito user pools associated with this authorizer. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.authorizationScopes">authorizationScopes</a></code> | <code>string[]</code> | A list of authorization scopes configured on the method. |

---

##### `authorizerId`<sup>Required</sup> <a name="authorizerId" id="@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.authorizerId"></a>

```typescript
public readonly authorizerId: string;
```

- *Type:* string

Unique identifier for this authorizer.

---

##### `userPools`<sup>Required</sup> <a name="userPools" id="@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.userPools"></a>

```typescript
public readonly userPools: IUserPool[];
```

- *Type:* aws-cdk-lib.aws_cognito.IUserPool[]

The Cognito user pools associated with this authorizer.

---

##### `authorizationScopes`<sup>Optional</sup> <a name="authorizationScopes" id="@aws-prototyping-sdk/type-safe-api.CognitoAuthorizerProps.property.authorizationScopes"></a>

```typescript
public readonly authorizationScopes: string[];
```

- *Type:* string[]
- *Default:* []

A list of authorization scopes configured on the method.

When used as the default authorizer, these scopes will be
applied to all methods without an authorizer at the integration level.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-method.html#cfn-apigateway-method-authorizationscopes](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-method.html#cfn-apigateway-method-authorizationscopes)

---

### CustomAuthorizerProps <a name="CustomAuthorizerProps" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps"></a>

Properties used to configure a custom authorizer.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.Initializer"></a>

```typescript
import { CustomAuthorizerProps } from '@aws-prototyping-sdk/type-safe-api'

const customAuthorizerProps: CustomAuthorizerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.authorizerId">authorizerId</a></code> | <code>string</code> | Unique identifier for this authorizer. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.function">function</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | The lambda function used to authorize requests. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.authorizerResultTtlInSeconds">authorizerResultTtlInSeconds</a></code> | <code>number</code> | The number of seconds during which the authorizer result is cached. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.identitySource">identitySource</a></code> | <code>string</code> | The source of the identity in an incoming request. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.type">type</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerType">CustomAuthorizerType</a></code> | The type of custom authorizer. |

---

##### `authorizerId`<sup>Required</sup> <a name="authorizerId" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.authorizerId"></a>

```typescript
public readonly authorizerId: string;
```

- *Type:* string

Unique identifier for this authorizer.

---

##### `function`<sup>Required</sup> <a name="function" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.function"></a>

```typescript
public readonly function: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

The lambda function used to authorize requests.

---

##### `authorizerResultTtlInSeconds`<sup>Optional</sup> <a name="authorizerResultTtlInSeconds" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.authorizerResultTtlInSeconds"></a>

```typescript
public readonly authorizerResultTtlInSeconds: number;
```

- *Type:* number
- *Default:* 300

The number of seconds during which the authorizer result is cached.

---

##### `identitySource`<sup>Optional</sup> <a name="identitySource" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.identitySource"></a>

```typescript
public readonly identitySource: string;
```

- *Type:* string
- *Default:* "method.request.header.Authorization"

The source of the identity in an incoming request.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-authorizer.html#cfn-apigateway-authorizer-identitysource](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-authorizer.html#cfn-apigateway-authorizer-identitysource)

---

##### `type`<sup>Optional</sup> <a name="type" id="@aws-prototyping-sdk/type-safe-api.CustomAuthorizerProps.property.type"></a>

```typescript
public readonly type: CustomAuthorizerType;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.CustomAuthorizerType">CustomAuthorizerType</a>
- *Default:* CustomAuthorizerType.TOKEN

The type of custom authorizer.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-authorizer.html#cfn-apigateway-authorizer-type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-authorizer.html#cfn-apigateway-authorizer-type)

---

### DocumentationConfiguration <a name="DocumentationConfiguration" id="@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration"></a>

Configuration for generated documentation.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration.Initializer"></a>

```typescript
import { DocumentationConfiguration } from '@aws-prototyping-sdk/type-safe-api'

const documentationConfiguration: DocumentationConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration.property.formats">formats</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.DocumentationFormat">DocumentationFormat</a>[]</code> | Formats for generated documentation. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration.property.options">options</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions">GeneratedDocumentationOptions</a></code> | Options for the generated documentation projects. |

---

##### `formats`<sup>Required</sup> <a name="formats" id="@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration.property.formats"></a>

```typescript
public readonly formats: DocumentationFormat[];
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.DocumentationFormat">DocumentationFormat</a>[]

Formats for generated documentation.

---

##### `options`<sup>Optional</sup> <a name="options" id="@aws-prototyping-sdk/type-safe-api.DocumentationConfiguration.property.options"></a>

```typescript
public readonly options: GeneratedDocumentationOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions">GeneratedDocumentationOptions</a>

Options for the generated documentation projects.

Note that only those provided for the specified formats will apply

---

### GeneratedCodeProjects <a name="GeneratedCodeProjects" id="@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects"></a>

Generated code projects.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.Initializer"></a>

```typescript
import { GeneratedCodeProjects } from '@aws-prototyping-sdk/type-safe-api'

const generatedCodeProjects: GeneratedCodeProjects = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.java">java</a></code> | <code>projen.java.JavaProject</code> | Generated java project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.python">python</a></code> | <code>projen.python.PythonProject</code> | Generated python project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.typescript">typescript</a></code> | <code>projen.typescript.TypeScriptProject</code> | Generated typescript project. |

---

##### `java`<sup>Optional</sup> <a name="java" id="@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.java"></a>

```typescript
public readonly java: JavaProject;
```

- *Type:* projen.java.JavaProject

Generated java project.

---

##### `python`<sup>Optional</sup> <a name="python" id="@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.python"></a>

```typescript
public readonly python: PythonProject;
```

- *Type:* projen.python.PythonProject

Generated python project.

---

##### `typescript`<sup>Optional</sup> <a name="typescript" id="@aws-prototyping-sdk/type-safe-api.GeneratedCodeProjects.property.typescript"></a>

```typescript
public readonly typescript: TypeScriptProject;
```

- *Type:* projen.typescript.TypeScriptProject

Generated typescript project.

---

### GeneratedDocumentationOptions <a name="GeneratedDocumentationOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions"></a>

Options for generated documentation projects.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.Initializer"></a>

```typescript
import { GeneratedDocumentationOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedDocumentationOptions: GeneratedDocumentationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.html2">html2</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions">GeneratedHtml2DocumentationOptions</a></code> | Generated html2 documentation project options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.htmlRedoc">htmlRedoc</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions">GeneratedHtmlRedocDocumentationOptions</a></code> | Generated html redoc documentation project options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.markdown">markdown</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedMarkdownDocumentationOptions">GeneratedMarkdownDocumentationOptions</a></code> | Generated markdown documentation project options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.plantuml">plantuml</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPlantumlDocumentationOptions">GeneratedPlantumlDocumentationOptions</a></code> | Generated plantuml documentation project options. |

---

##### `html2`<sup>Optional</sup> <a name="html2" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.html2"></a>

```typescript
public readonly html2: GeneratedHtml2DocumentationOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions">GeneratedHtml2DocumentationOptions</a>

Generated html2 documentation project options.

---

##### `htmlRedoc`<sup>Optional</sup> <a name="htmlRedoc" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.htmlRedoc"></a>

```typescript
public readonly htmlRedoc: GeneratedHtmlRedocDocumentationOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions">GeneratedHtmlRedocDocumentationOptions</a>

Generated html redoc documentation project options.

---

##### `markdown`<sup>Optional</sup> <a name="markdown" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.markdown"></a>

```typescript
public readonly markdown: GeneratedMarkdownDocumentationOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedMarkdownDocumentationOptions">GeneratedMarkdownDocumentationOptions</a>

Generated markdown documentation project options.

---

##### `plantuml`<sup>Optional</sup> <a name="plantuml" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationOptions.property.plantuml"></a>

```typescript
public readonly plantuml: GeneratedPlantumlDocumentationOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPlantumlDocumentationOptions">GeneratedPlantumlDocumentationOptions</a>

Generated plantuml documentation project options.

---

### GeneratedDocumentationProjects <a name="GeneratedDocumentationProjects" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects"></a>

Generated documentation project references.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.Initializer"></a>

```typescript
import { GeneratedDocumentationProjects } from '@aws-prototyping-sdk/type-safe-api'

const generatedDocumentationProjects: GeneratedDocumentationProjects = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.html2">html2</a></code> | <code>projen.Project</code> | Generated html2 documentation project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.htmlRedoc">htmlRedoc</a></code> | <code>projen.Project</code> | Generated html redoc documentation project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.markdown">markdown</a></code> | <code>projen.Project</code> | Generated markdown documentation project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.plantuml">plantuml</a></code> | <code>projen.Project</code> | Generated plantuml documentation project. |

---

##### `html2`<sup>Optional</sup> <a name="html2" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.html2"></a>

```typescript
public readonly html2: Project;
```

- *Type:* projen.Project

Generated html2 documentation project.

---

##### `htmlRedoc`<sup>Optional</sup> <a name="htmlRedoc" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.htmlRedoc"></a>

```typescript
public readonly htmlRedoc: Project;
```

- *Type:* projen.Project

Generated html redoc documentation project.

---

##### `markdown`<sup>Optional</sup> <a name="markdown" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.markdown"></a>

```typescript
public readonly markdown: Project;
```

- *Type:* projen.Project

Generated markdown documentation project.

---

##### `plantuml`<sup>Optional</sup> <a name="plantuml" id="@aws-prototyping-sdk/type-safe-api.GeneratedDocumentationProjects.property.plantuml"></a>

```typescript
public readonly plantuml: Project;
```

- *Type:* projen.Project

Generated plantuml documentation project.

---

### GeneratedHandlersCodeOptions <a name="GeneratedHandlersCodeOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions"></a>

Options for lambda handler projects for implementing API operations.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.Initializer"></a>

```typescript
import { GeneratedHandlersCodeOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedHandlersCodeOptions: GeneratedHandlersCodeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.java">java</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions">GeneratedJavaHandlersOptions</a></code> | Options for the java handlers project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.python">python</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPythonHandlersOptions">GeneratedPythonHandlersOptions</a></code> | Options for the python handlers project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.typescript">typescript</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedTypeScriptHandlersOptions">GeneratedTypeScriptHandlersOptions</a></code> | Options for the typescript handlers project. |

---

##### `java`<sup>Optional</sup> <a name="java" id="@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.java"></a>

```typescript
public readonly java: GeneratedJavaHandlersOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions">GeneratedJavaHandlersOptions</a>

Options for the java handlers project.

These override the default inferred options.

---

##### `python`<sup>Optional</sup> <a name="python" id="@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.python"></a>

```typescript
public readonly python: GeneratedPythonHandlersOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPythonHandlersOptions">GeneratedPythonHandlersOptions</a>

Options for the python handlers project.

These override the default inferred options.

---

##### `typescript`<sup>Optional</sup> <a name="typescript" id="@aws-prototyping-sdk/type-safe-api.GeneratedHandlersCodeOptions.property.typescript"></a>

```typescript
public readonly typescript: GeneratedTypeScriptHandlersOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedTypeScriptHandlersOptions">GeneratedTypeScriptHandlersOptions</a>

Options for the typescript handlers project.

These override the default inferred options.

---

### GeneratedHtml2DocumentationOptions <a name="GeneratedHtml2DocumentationOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions"></a>

Options for the html2 documentation project.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions.Initializer"></a>

```typescript
import { GeneratedHtml2DocumentationOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedHtml2DocumentationOptions: GeneratedHtml2DocumentationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions.property.openApiGeneratorCliConfig">openApiGeneratorCliConfig</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a></code> | Configuration for the OpenAPI Generator CLI. |

---

##### `openApiGeneratorCliConfig`<sup>Optional</sup> <a name="openApiGeneratorCliConfig" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtml2DocumentationOptions.property.openApiGeneratorCliConfig"></a>

```typescript
public readonly openApiGeneratorCliConfig: OpenApiGeneratorCliConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a>

Configuration for the OpenAPI Generator CLI.

Overrides default values if specified.

> [https://github.com/OpenAPITools/openapi-generator-cli#configuration](https://github.com/OpenAPITools/openapi-generator-cli#configuration)

---

### GeneratedHtmlRedocDocumentationOptions <a name="GeneratedHtmlRedocDocumentationOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions"></a>

Options for the html redoc documentation project.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions.Initializer"></a>

```typescript
import { GeneratedHtmlRedocDocumentationOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedHtmlRedocDocumentationOptions: GeneratedHtmlRedocDocumentationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions.property.openApiGeneratorCliConfig">openApiGeneratorCliConfig</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a></code> | Configuration for the OpenAPI Generator CLI. |

---

##### `openApiGeneratorCliConfig`<sup>Optional</sup> <a name="openApiGeneratorCliConfig" id="@aws-prototyping-sdk/type-safe-api.GeneratedHtmlRedocDocumentationOptions.property.openApiGeneratorCliConfig"></a>

```typescript
public readonly openApiGeneratorCliConfig: OpenApiGeneratorCliConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a>

Configuration for the OpenAPI Generator CLI.

Overrides default values if specified.

> [https://github.com/OpenAPITools/openapi-generator-cli#configuration](https://github.com/OpenAPITools/openapi-generator-cli#configuration)

---

### GeneratedInfrastructureCodeOptions <a name="GeneratedInfrastructureCodeOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions"></a>

Options for generated infrastructure.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.Initializer"></a>

```typescript
import { GeneratedInfrastructureCodeOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedInfrastructureCodeOptions: GeneratedInfrastructureCodeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.java">java</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions">GeneratedJavaInfrastructureOptions</a></code> | Options for the generated java infrastructure project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.python">python</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPythonInfrastructureOptions">GeneratedPythonInfrastructureOptions</a></code> | Options for the generated python infrastructure project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.typescript">typescript</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedTypeScriptInfrastructureOptions">GeneratedTypeScriptInfrastructureOptions</a></code> | Options for the generated typescript infrastructure project. |

---

##### `java`<sup>Optional</sup> <a name="java" id="@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.java"></a>

```typescript
public readonly java: GeneratedJavaInfrastructureOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions">GeneratedJavaInfrastructureOptions</a>

Options for the generated java infrastructure project.

These override the default inferred options.

---

##### `python`<sup>Optional</sup> <a name="python" id="@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.python"></a>

```typescript
public readonly python: GeneratedPythonInfrastructureOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedPythonInfrastructureOptions">GeneratedPythonInfrastructureOptions</a>

Options for the generated python infrastructure project.

These override the default inferred options.

---

##### `typescript`<sup>Optional</sup> <a name="typescript" id="@aws-prototyping-sdk/type-safe-api.GeneratedInfrastructureCodeOptions.property.typescript"></a>

```typescript
public readonly typescript: GeneratedTypeScriptInfrastructureOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.GeneratedTypeScriptInfrastructureOptions">GeneratedTypeScriptInfrastructureOptions</a>

Options for the generated typescript infrastructure project.

These override the default inferred options.

---

### GeneratedJavaHandlersOptions <a name="GeneratedJavaHandlersOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions"></a>

Options for configuring a generated java handlers project.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.Initializer"></a>

```typescript
import { GeneratedJavaHandlersOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedJavaHandlersOptions: GeneratedJavaHandlersOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.name">name</a></code> | <code>string</code> | This is the name of your project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitIgnoreOptions">gitIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .gitignore file. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitOptions">gitOptions</a></code> | <code>projen.GitOptions</code> | Configuration options for git. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.logging">logging</a></code> | <code>projen.LoggerOptions</code> | Configure logging options such as verbosity. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.outdir">outdir</a></code> | <code>string</code> | The root directory of the project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.parent">parent</a></code> | <code>projen.Project</code> | The parent project, if this project is part of a bigger project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenCommand">projenCommand</a></code> | <code>string</code> | The shell command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJson">projenrcJson</a></code> | <code>boolean</code> | Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJsonOptions">projenrcJsonOptions</a></code> | <code>projen.ProjenrcJsonOptions</code> | Options for .projenrc.json. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.renovatebot">renovatebot</a></code> | <code>boolean</code> | Use renovatebot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.renovatebotOptions">renovatebotOptions</a></code> | <code>projen.RenovatebotOptions</code> | Options for renovatebot. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoApproveOptions">autoApproveOptions</a></code> | <code>projen.github.AutoApproveOptions</code> | Enable and configure the 'auto approve' workflow. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoMerge">autoMerge</a></code> | <code>boolean</code> | Enable automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoMergeOptions">autoMergeOptions</a></code> | <code>projen.github.AutoMergeOptions</code> | Configure options for automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.clobber">clobber</a></code> | <code>boolean</code> | Add a `clobber` task which resets the repo to origin. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.devContainer">devContainer</a></code> | <code>boolean</code> | Add a VSCode development environment (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.github">github</a></code> | <code>boolean</code> | Enable GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.githubOptions">githubOptions</a></code> | <code>projen.github.GitHubOptions</code> | Options for GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitpod">gitpod</a></code> | <code>boolean</code> | Add a Gitpod development environment. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.mergify">mergify</a></code> | <code>boolean</code> | Whether mergify should be enabled on this repository or not. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.mergifyOptions">mergifyOptions</a></code> | <code>projen.github.MergifyOptions</code> | Options for mergify. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | Which type of project this is (library/app). |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenCredentials">projenCredentials</a></code> | <code>projen.github.GithubCredentials</code> | Choose a method of providing GitHub API access for projen workflows. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenTokenSecret">projenTokenSecret</a></code> | <code>string</code> | The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.readme">readme</a></code> | <code>projen.SampleReadmeProps</code> | The README setup. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.stale">stale</a></code> | <code>boolean</code> | Auto-close of stale issues and pull request. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.staleOptions">staleOptions</a></code> | <code>projen.github.StaleOptions</code> | Auto-close stale issues and pull requests. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.vscode">vscode</a></code> | <code>boolean</code> | Enable VSCode integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.artifactId">artifactId</a></code> | <code>string</code> | The artifactId is generally the name that the project is known by. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.groupId">groupId</a></code> | <code>string</code> | This is generally unique amongst an organization or a project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.version">version</a></code> | <code>string</code> | This is the last piece of the naming puzzle. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.description">description</a></code> | <code>string</code> | Description of a project is always good. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.packaging">packaging</a></code> | <code>string</code> | Project packaging format. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.url">url</a></code> | <code>string</code> | The URL, like the name, is not required. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.compileOptions">compileOptions</a></code> | <code>projen.java.MavenCompileOptions</code> | Compile options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.deps">deps</a></code> | <code>string[]</code> | List of runtime dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.distdir">distdir</a></code> | <code>string</code> | Final artifact output directory. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.junit">junit</a></code> | <code>boolean</code> | Include junit tests. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.junitOptions">junitOptions</a></code> | <code>projen.java.JunitOptions</code> | junit options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.packagingOptions">packagingOptions</a></code> | <code>projen.java.MavenPackagingOptions</code> | Packaging options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJava">projenrcJava</a></code> | <code>boolean</code> | Use projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJavaOptions">projenrcJavaOptions</a></code> | <code>projen.java.ProjenrcOptions</code> | Options related to projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.testDeps">testDeps</a></code> | <code>string[]</code> | List of test dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.sample">sample</a></code> | <code>boolean</code> | Include sample code and test if the relevant directories don't exist. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.sampleJavaPackage">sampleJavaPackage</a></code> | <code>string</code> | The java package to use for the code sample. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.openApiGeneratorCliConfig">openApiGeneratorCliConfig</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a></code> | Configuration for the OpenAPI Generator CLI. |

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* $BASEDIR

This is the name of your project.

---

##### `commitGenerated`<sup>Optional</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to commit the managed files by default.

---

##### `gitIgnoreOptions`<sup>Optional</sup> <a name="gitIgnoreOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitIgnoreOptions"></a>

```typescript
public readonly gitIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .gitignore file.

---

##### `gitOptions`<sup>Optional</sup> <a name="gitOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitOptions"></a>

```typescript
public readonly gitOptions: GitOptions;
```

- *Type:* projen.GitOptions

Configuration options for git.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.logging"></a>

```typescript
public readonly logging: LoggerOptions;
```

- *Type:* projen.LoggerOptions
- *Default:* {}

Configure logging options such as verbosity.

---

##### `outdir`<sup>Optional</sup> <a name="outdir" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string
- *Default:* "."

The root directory of the project.

Relative to this directory, all files are synthesized.

If this project has a parent, this directory is relative to the parent
directory and it cannot be the same as the parent or any of it's other
sub-projects.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

The parent project, if this project is part of a bigger project.

---

##### `projenCommand`<sup>Optional</sup> <a name="projenCommand" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string
- *Default:* "npx projen"

The shell command to use in order to run the projen CLI.

Can be used to customize in special environments.

---

##### `projenrcJson`<sup>Optional</sup> <a name="projenrcJson" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJson"></a>

```typescript
public readonly projenrcJson: boolean;
```

- *Type:* boolean
- *Default:* false

Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation.

---

##### `projenrcJsonOptions`<sup>Optional</sup> <a name="projenrcJsonOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJsonOptions"></a>

```typescript
public readonly projenrcJsonOptions: ProjenrcJsonOptions;
```

- *Type:* projen.ProjenrcJsonOptions
- *Default:* default options

Options for .projenrc.json.

---

##### `renovatebot`<sup>Optional</sup> <a name="renovatebot" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.renovatebot"></a>

```typescript
public readonly renovatebot: boolean;
```

- *Type:* boolean
- *Default:* false

Use renovatebot to handle dependency upgrades.

---

##### `renovatebotOptions`<sup>Optional</sup> <a name="renovatebotOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.renovatebotOptions"></a>

```typescript
public readonly renovatebotOptions: RenovatebotOptions;
```

- *Type:* projen.RenovatebotOptions
- *Default:* default options

Options for renovatebot.

---

##### `autoApproveOptions`<sup>Optional</sup> <a name="autoApproveOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoApproveOptions"></a>

```typescript
public readonly autoApproveOptions: AutoApproveOptions;
```

- *Type:* projen.github.AutoApproveOptions
- *Default:* auto approve is disabled

Enable and configure the 'auto approve' workflow.

---

##### `autoMerge`<sup>Optional</sup> <a name="autoMerge" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoMerge"></a>

```typescript
public readonly autoMerge: boolean;
```

- *Type:* boolean
- *Default:* true

Enable automatic merging on GitHub.

Has no effect if `github.mergify`
is set to false.

---

##### `autoMergeOptions`<sup>Optional</sup> <a name="autoMergeOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.autoMergeOptions"></a>

```typescript
public readonly autoMergeOptions: AutoMergeOptions;
```

- *Type:* projen.github.AutoMergeOptions
- *Default:* see defaults in `AutoMergeOptions`

Configure options for automatic merging on GitHub.

Has no effect if
`github.mergify` or `autoMerge` is set to false.

---

##### `clobber`<sup>Optional</sup> <a name="clobber" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.clobber"></a>

```typescript
public readonly clobber: boolean;
```

- *Type:* boolean
- *Default:* true, but false for subprojects

Add a `clobber` task which resets the repo to origin.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.devContainer"></a>

```typescript
public readonly devContainer: boolean;
```

- *Type:* boolean
- *Default:* false

Add a VSCode development environment (used for GitHub Codespaces).

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.github"></a>

```typescript
public readonly github: boolean;
```

- *Type:* boolean
- *Default:* true

Enable GitHub integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `githubOptions`<sup>Optional</sup> <a name="githubOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.githubOptions"></a>

```typescript
public readonly githubOptions: GitHubOptions;
```

- *Type:* projen.github.GitHubOptions
- *Default:* see GitHubOptions

Options for GitHub integration.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.gitpod"></a>

```typescript
public readonly gitpod: boolean;
```

- *Type:* boolean
- *Default:* false

Add a Gitpod development environment.

---

##### ~~`mergify`~~<sup>Optional</sup> <a name="mergify" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.mergify"></a>

- *Deprecated:* use `githubOptions.mergify` instead

```typescript
public readonly mergify: boolean;
```

- *Type:* boolean
- *Default:* true

Whether mergify should be enabled on this repository or not.

---

##### ~~`mergifyOptions`~~<sup>Optional</sup> <a name="mergifyOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.mergifyOptions"></a>

- *Deprecated:* use `githubOptions.mergifyOptions` instead

```typescript
public readonly mergifyOptions: MergifyOptions;
```

- *Type:* projen.github.MergifyOptions
- *Default:* default options

Options for mergify.

---

##### ~~`projectType`~~<sup>Optional</sup> <a name="projectType" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projectType"></a>

- *Deprecated:* no longer supported at the base project level

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType
- *Default:* ProjectType.UNKNOWN

Which type of project this is (library/app).

---

##### `projenCredentials`<sup>Optional</sup> <a name="projenCredentials" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenCredentials"></a>

```typescript
public readonly projenCredentials: GithubCredentials;
```

- *Type:* projen.github.GithubCredentials
- *Default:* use a personal access token named PROJEN_GITHUB_TOKEN

Choose a method of providing GitHub API access for projen workflows.

---

##### ~~`projenTokenSecret`~~<sup>Optional</sup> <a name="projenTokenSecret" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenTokenSecret"></a>

- *Deprecated:* use `projenCredentials`

```typescript
public readonly projenTokenSecret: string;
```

- *Type:* string
- *Default:* "PROJEN_GITHUB_TOKEN"

The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows.

This token needs to have the `repo`, `workflows`
and `packages` scope.

---

##### `readme`<sup>Optional</sup> <a name="readme" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.readme"></a>

```typescript
public readonly readme: SampleReadmeProps;
```

- *Type:* projen.SampleReadmeProps
- *Default:* { filename: 'README.md', contents: '# replace this' }

The README setup.

---

*Example*

```typescript
"{ filename: 'readme.md', contents: '# title' }"
```


##### `stale`<sup>Optional</sup> <a name="stale" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.stale"></a>

```typescript
public readonly stale: boolean;
```

- *Type:* boolean
- *Default:* false

Auto-close of stale issues and pull request.

See `staleOptions` for options.

---

##### `staleOptions`<sup>Optional</sup> <a name="staleOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.staleOptions"></a>

```typescript
public readonly staleOptions: StaleOptions;
```

- *Type:* projen.github.StaleOptions
- *Default:* see defaults in `StaleOptions`

Auto-close stale issues and pull requests.

To disable set `stale` to `false`.

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.vscode"></a>

```typescript
public readonly vscode: boolean;
```

- *Type:* boolean
- *Default:* true

Enable VSCode integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `artifactId`<sup>Required</sup> <a name="artifactId" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.artifactId"></a>

```typescript
public readonly artifactId: string;
```

- *Type:* string
- *Default:* "my-app"

The artifactId is generally the name that the project is known by.

Although
the groupId is important, people within the group will rarely mention the
groupId in discussion (they are often all be the same ID, such as the
MojoHaus project groupId: org.codehaus.mojo). It, along with the groupId,
creates a key that separates this project from every other project in the
world (at least, it should :) ). Along with the groupId, the artifactId
fully defines the artifact's living quarters within the repository. In the
case of the above project, my-project lives in
$M2_REPO/org/codehaus/mojo/my-project.

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string
- *Default:* "org.acme"

This is generally unique amongst an organization or a project.

For example,
all core Maven artifacts do (well, should) live under the groupId
org.apache.maven. Group ID's do not necessarily use the dot notation, for
example, the junit project. Note that the dot-notated groupId does not have
to correspond to the package structure that the project contains. It is,
however, a good practice to follow. When stored within a repository, the
group acts much like the Java packaging structure does in an operating
system. The dots are replaced by OS specific directory separators (such as
'/' in Unix) which becomes a relative directory structure from the base
repository. In the example given, the org.codehaus.mojo group lives within
the directory $M2_REPO/org/codehaus/mojo.

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string
- *Default:* "0.1.0"

This is the last piece of the naming puzzle.

groupId:artifactId denotes a
single project but they cannot delineate which incarnation of that project
we are talking about. Do we want the junit:junit of 2018 (version 4.12), or
of 2007 (version 3.8.2)? In short: code changes, those changes should be
versioned, and this element keeps those versions in line. It is also used
within an artifact's repository to separate versions from each other.
my-project version 1.0 files live in the directory structure
$M2_REPO/org/codehaus/mojo/my-project/1.0.

---

##### `description`<sup>Optional</sup> <a name="description" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string
- *Default:* undefined

Description of a project is always good.

Although this should not replace
formal documentation, a quick comment to any readers of the POM is always
helpful.

---

##### `packaging`<sup>Optional</sup> <a name="packaging" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.packaging"></a>

```typescript
public readonly packaging: string;
```

- *Type:* string
- *Default:* "jar"

Project packaging format.

---

##### `url`<sup>Optional</sup> <a name="url" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string
- *Default:* undefined

The URL, like the name, is not required.

This is a nice gesture for
projects users, however, so that they know where the project lives.

---

##### `compileOptions`<sup>Optional</sup> <a name="compileOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.compileOptions"></a>

```typescript
public readonly compileOptions: MavenCompileOptions;
```

- *Type:* projen.java.MavenCompileOptions
- *Default:* defaults

Compile options.

---

##### `deps`<sup>Optional</sup> <a name="deps" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.deps"></a>

```typescript
public readonly deps: string[];
```

- *Type:* string[]
- *Default:* []

List of runtime dependencies for this project.

Dependencies use the format: `<groupId>/<artifactId>@<semver>`

Additional dependencies can be added via `project.addDependency()`.

---

##### `distdir`<sup>Optional</sup> <a name="distdir" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.distdir"></a>

```typescript
public readonly distdir: string;
```

- *Type:* string
- *Default:* "dist/java"

Final artifact output directory.

---

##### `junit`<sup>Optional</sup> <a name="junit" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.junit"></a>

```typescript
public readonly junit: boolean;
```

- *Type:* boolean
- *Default:* true

Include junit tests.

---

##### `junitOptions`<sup>Optional</sup> <a name="junitOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.junitOptions"></a>

```typescript
public readonly junitOptions: JunitOptions;
```

- *Type:* projen.java.JunitOptions
- *Default:* defaults

junit options.

---

##### `packagingOptions`<sup>Optional</sup> <a name="packagingOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.packagingOptions"></a>

```typescript
public readonly packagingOptions: MavenPackagingOptions;
```

- *Type:* projen.java.MavenPackagingOptions
- *Default:* defaults

Packaging options.

---

##### `projenrcJava`<sup>Optional</sup> <a name="projenrcJava" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJava"></a>

```typescript
public readonly projenrcJava: boolean;
```

- *Type:* boolean
- *Default:* true

Use projenrc in java.

This will install `projen` as a java dependency and will add a `synth` task which
will compile & execute `main()` from `src/main/java/projenrc.java`.

---

##### `projenrcJavaOptions`<sup>Optional</sup> <a name="projenrcJavaOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.projenrcJavaOptions"></a>

```typescript
public readonly projenrcJavaOptions: ProjenrcOptions;
```

- *Type:* projen.java.ProjenrcOptions
- *Default:* default options

Options related to projenrc in java.

---

##### `testDeps`<sup>Optional</sup> <a name="testDeps" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.testDeps"></a>

```typescript
public readonly testDeps: string[];
```

- *Type:* string[]
- *Default:* []

List of test dependencies for this project.

Dependencies use the format: `<groupId>/<artifactId>@<semver>`

Additional dependencies can be added via `project.addTestDependency()`.

---

##### `sample`<sup>Optional</sup> <a name="sample" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.sample"></a>

```typescript
public readonly sample: boolean;
```

- *Type:* boolean
- *Default:* true

Include sample code and test if the relevant directories don't exist.

---

##### `sampleJavaPackage`<sup>Optional</sup> <a name="sampleJavaPackage" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.sampleJavaPackage"></a>

```typescript
public readonly sampleJavaPackage: string;
```

- *Type:* string
- *Default:* "org.acme"

The java package to use for the code sample.

---

##### `openApiGeneratorCliConfig`<sup>Optional</sup> <a name="openApiGeneratorCliConfig" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaHandlersOptions.property.openApiGeneratorCliConfig"></a>

```typescript
public readonly openApiGeneratorCliConfig: OpenApiGeneratorCliConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a>

Configuration for the OpenAPI Generator CLI.

Overrides default values if specified.

> [https://github.com/OpenAPITools/openapi-generator-cli#configuration](https://github.com/OpenAPITools/openapi-generator-cli#configuration)

---

### GeneratedJavaInfrastructureOptions <a name="GeneratedJavaInfrastructureOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions"></a>

Options for configuring a generated java infrastructure project.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.Initializer"></a>

```typescript
import { GeneratedJavaInfrastructureOptions } from '@aws-prototyping-sdk/type-safe-api'

const generatedJavaInfrastructureOptions: GeneratedJavaInfrastructureOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.name">name</a></code> | <code>string</code> | This is the name of your project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.gitIgnoreOptions">gitIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .gitignore file. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.gitOptions">gitOptions</a></code> | <code>projen.GitOptions</code> | Configuration options for git. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.logging">logging</a></code> | <code>projen.LoggerOptions</code> | Configure logging options such as verbosity. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.outdir">outdir</a></code> | <code>string</code> | The root directory of the project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.parent">parent</a></code> | <code>projen.Project</code> | The parent project, if this project is part of a bigger project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenCommand">projenCommand</a></code> | <code>string</code> | The shell command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenrcJson">projenrcJson</a></code> | <code>boolean</code> | Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenrcJsonOptions">projenrcJsonOptions</a></code> | <code>projen.ProjenrcJsonOptions</code> | Options for .projenrc.json. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.renovatebot">renovatebot</a></code> | <code>boolean</code> | Use renovatebot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.renovatebotOptions">renovatebotOptions</a></code> | <code>projen.RenovatebotOptions</code> | Options for renovatebot. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.autoApproveOptions">autoApproveOptions</a></code> | <code>projen.github.AutoApproveOptions</code> | Enable and configure the 'auto approve' workflow. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.autoMerge">autoMerge</a></code> | <code>boolean</code> | Enable automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.autoMergeOptions">autoMergeOptions</a></code> | <code>projen.github.AutoMergeOptions</code> | Configure options for automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.clobber">clobber</a></code> | <code>boolean</code> | Add a `clobber` task which resets the repo to origin. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.devContainer">devContainer</a></code> | <code>boolean</code> | Add a VSCode development environment (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.github">github</a></code> | <code>boolean</code> | Enable GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.githubOptions">githubOptions</a></code> | <code>projen.github.GitHubOptions</code> | Options for GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.gitpod">gitpod</a></code> | <code>boolean</code> | Add a Gitpod development environment. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.mergify">mergify</a></code> | <code>boolean</code> | Whether mergify should be enabled on this repository or not. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.mergifyOptions">mergifyOptions</a></code> | <code>projen.github.MergifyOptions</code> | Options for mergify. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | Which type of project this is (library/app). |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenCredentials">projenCredentials</a></code> | <code>projen.github.GithubCredentials</code> | Choose a method of providing GitHub API access for projen workflows. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenTokenSecret">projenTokenSecret</a></code> | <code>string</code> | The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.readme">readme</a></code> | <code>projen.SampleReadmeProps</code> | The README setup. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.stale">stale</a></code> | <code>boolean</code> | Auto-close of stale issues and pull request. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.staleOptions">staleOptions</a></code> | <code>projen.github.StaleOptions</code> | Auto-close stale issues and pull requests. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.vscode">vscode</a></code> | <code>boolean</code> | Enable VSCode integration. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.artifactId">artifactId</a></code> | <code>string</code> | The artifactId is generally the name that the project is known by. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.groupId">groupId</a></code> | <code>string</code> | This is generally unique amongst an organization or a project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.version">version</a></code> | <code>string</code> | This is the last piece of the naming puzzle. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.description">description</a></code> | <code>string</code> | Description of a project is always good. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.packaging">packaging</a></code> | <code>string</code> | Project packaging format. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.url">url</a></code> | <code>string</code> | The URL, like the name, is not required. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.compileOptions">compileOptions</a></code> | <code>projen.java.MavenCompileOptions</code> | Compile options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.deps">deps</a></code> | <code>string[]</code> | List of runtime dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.distdir">distdir</a></code> | <code>string</code> | Final artifact output directory. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.junit">junit</a></code> | <code>boolean</code> | Include junit tests. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.junitOptions">junitOptions</a></code> | <code>projen.java.JunitOptions</code> | junit options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.packagingOptions">packagingOptions</a></code> | <code>projen.java.MavenPackagingOptions</code> | Packaging options. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenrcJava">projenrcJava</a></code> | <code>boolean</code> | Use projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenrcJavaOptions">projenrcJavaOptions</a></code> | <code>projen.java.ProjenrcOptions</code> | Options related to projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.testDeps">testDeps</a></code> | <code>string[]</code> | List of test dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.sample">sample</a></code> | <code>boolean</code> | Include sample code and test if the relevant directories don't exist. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.sampleJavaPackage">sampleJavaPackage</a></code> | <code>string</code> | The java package to use for the code sample. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.openApiGeneratorCliConfig">openApiGeneratorCliConfig</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.OpenApiGeneratorCliConfig">OpenApiGeneratorCliConfig</a></code> | Configuration for the OpenAPI Generator CLI. |
| <code><a href="#@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.mockDataOptions">mockDataOptions</a></code> | <code><a href="#@aws-prototyping-sdk/type-safe-api.MockResponseDataGenerationOptions">MockResponseDataGenerationOptions</a></code> | Options for the generated mock response data. |

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* $BASEDIR

This is the name of your project.

---

##### `commitGenerated`<sup>Optional</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to commit the managed files by default.

---

##### `gitIgnoreOptions`<sup>Optional</sup> <a name="gitIgnoreOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.gitIgnoreOptions"></a>

```typescript
public readonly gitIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .gitignore file.

---

##### `gitOptions`<sup>Optional</sup> <a name="gitOptions" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.gitOptions"></a>

```typescript
public readonly gitOptions: GitOptions;
```

- *Type:* projen.GitOptions

Configuration options for git.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.logging"></a>

```typescript
public readonly logging: LoggerOptions;
```

- *Type:* projen.LoggerOptions
- *Default:* {}

Configure logging options such as verbosity.

---

##### `outdir`<sup>Optional</sup> <a name="outdir" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string
- *Default:* "."

The root directory of the project.

Relative to this directory, all files are synthesized.

If this project has a parent, this directory is relative to the parent
directory and it cannot be the same as the parent or any of it's other
sub-projects.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

The parent project, if this project is part of a bigger project.

---

##### `projenCommand`<sup>Optional</sup> <a name="projenCommand" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string
- *Default:* "npx projen"

The shell command to use in order to run the projen CLI.

Can be used to customize in special environments.

---

##### `projenrcJson`<sup>Optional</sup> <a name="projenrcJson" id="@aws-prototyping-sdk/type-safe-api.GeneratedJavaInfrastructureOptions.property.projenrcJson"></a>

```typescript
public readonly projenrcJson: boolean;
```

- *Type:* boolean
- *Default:* false

Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation.

---

[...]
